#include "SPT.h"
#include <iostream>
#include <stack>

int main()
{
	typedef DenseGRAPH<Edge> dGraph;
	
	dGraph g( 8, true );

	g.insert( new Edge( 1, 6, 1.0 ) );
	g.insert( new Edge( 1, 2, 2.5 ) );	
	g.insert( new Edge( 1, 4, 3.0 ) );	
	g.insert( new Edge( 1, 5, 0.5 ) );	
	g.insert( new Edge( 2, 1, 0.5 ) );	
	g.insert( new Edge( 2, 3, 3.0 ) );
	g.insert( new Edge( 2, 4, 2.0 ) );
	g.insert( new Edge( 2, 5, 2.5 ) );
	g.insert( new Edge( 3, 4, 1.0 ) );
	g.insert( new Edge( 3, 7, 1.5 ) );
	g.insert( new Edge( 4, 5, 1.0 ) );
	g.insert( new Edge( 5, 4, 0.5 ) );
	g.insert( new Edge( 5, 6, 0.5 ) );
	g.insert( new Edge( 5, 7, 1.5 ) );
	g.insert( new Edge( 7, 6, 1.0 ) );

	
	// Find shortest path between nodes 2->7
	int source = 2;
	int target = 7;
	stack<int> path;

	SPT<dGraph, Edge> sp( g, source );
			
	while ( true )
	{
		Edge* e = sp.pathR( target );	
		path.push( target );
		if ( target == source ) break;
		target = e->v;			
	}

	// Print the path nodes
	while ( !path.empty() )
	{
		std::cout << path.top() << " ";
		path.pop();
	}
	

	return 0;
}